# coding: utf-8

"""
    Conekta API

    Conekta sdk

    The version of the OpenAPI document: 2.1.0
    Contact: engineering@conekta.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PayoutOrderPayoutsItem(BaseModel):
    """
    PayoutOrderPayoutsItem
    """ # noqa: E501
    amount: StrictInt = Field(description="The amount of the payout.")
    currency: StrictStr = Field(description="The currency in which the payout is made.")
    expires_at: Optional[StrictInt] = Field(default=None, description="The expiration date of the payout.")
    id: StrictStr = Field(description="The id of the payout.")
    livemode: StrictBool = Field(description="The live mode of the payout.")
    object: StrictStr = Field(description="The object of the payout.")
    payout_order_id: Optional[StrictStr] = Field(default=None, description="The id of the payout order.")
    status: Optional[StrictStr] = Field(default=None, description="The status of the payout.")
    __properties: ClassVar[List[str]] = ["amount", "currency", "expires_at", "id", "livemode", "object", "payout_order_id", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PayoutOrderPayoutsItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PayoutOrderPayoutsItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount": obj.get("amount"),
            "currency": obj.get("currency"),
            "expires_at": obj.get("expires_at"),
            "id": obj.get("id"),
            "livemode": obj.get("livemode"),
            "object": obj.get("object"),
            "payout_order_id": obj.get("payout_order_id"),
            "status": obj.get("status")
        })
        return _obj


