# coding: utf-8

"""
    Conekta API

    Conekta sdk

    The version of the OpenAPI document: 2.1.0
    Contact: engineering@conekta.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class TransferMethodResponse(BaseModel):
    """
    Method used to make the transfer.
    """ # noqa: E501
    account_holder: Optional[StrictStr] = Field(default=None, description="Name of the account holder.")
    account_number: Optional[StrictStr] = Field(default=None, description="Account number of the bank account.")
    bank: Optional[StrictStr] = Field(default=None, description="Name of the bank.")
    created_at: Optional[StrictInt] = Field(default=None, description="Date and time of creation of the transfer.")
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier of the transfer.")
    object: Optional[StrictStr] = Field(default=None, description="Object name, which is bank_transfer_payout_method.")
    payee_id: Optional[StrictStr] = Field(default=None, description="Unique identifier of the payee.")
    type: Optional[StrictStr] = Field(default=None, description="Type of the payee.")
    __properties: ClassVar[List[str]] = ["account_holder", "account_number", "bank", "created_at", "id", "object", "payee_id", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransferMethodResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransferMethodResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_holder": obj.get("account_holder"),
            "account_number": obj.get("account_number"),
            "bank": obj.get("bank"),
            "created_at": obj.get("created_at"),
            "id": obj.get("id"),
            "object": obj.get("object"),
            "payee_id": obj.get("payee_id"),
            "type": obj.get("type")
        })
        return _obj


